; $Id: aliasing.pro,v 1.2 2001/11/05 14:14:24 aake Exp $
;-----------------------------------------------------------------------
PRO cosines,k,points=n,psym=psym
;
;  Plot cosine function
;
  default,n,8 & default,k,1 & default,psym,6            ; defaults

  dx=1./n
  x=findgen(n+1)*dx                                     ; coarse scale
  xx=findgen(20*n)*dx/20.                               ; fine scale

  plot,x,cos(x*k*2.*!pi),ystyle=3,psym=psym             ; points
  oplot,xx,cos(xx*k*2.*!pi)                             ; smooth curve
  oplot,[xx(0),xx(20*n-1)],[0,0]                        ; zero-line
  for i=0,n-1 do oplot,[x(i),x(i)],[-2,2],line=1        ; vertical lines

  if k gt n/2 then $
    oplot,xx,cos(xx*(n-k)*2.*!pi),line=2                ; mirror frequency

END
;-----------------------------------------------------------------------
PRO slider_event, ev
;
;  Event handler.  Gets called when something happens, with info on
;  the event in a structure (ev).

  k=ev.value                                            ; slider value
  cosines,k,points=npoints
END
;-----------------------------------------------------------------------
PRO quit_event, ev
;
;  Event handler.  Gets called when something happens, with info on
;  the event in a structure (ev).

  widget_control, ev.top, /destroy                      ; delete widgets
END
;-----------------------------------------------------------------------
PRO aliasing, points
;
;  COMMON widgets, base, npoints, slider, quit

  default, points, 8
  npoints = points

  base    = widget_base (title= 'Aliasing', /column)    ; base widget
  widgets = widget_base (base, /row)                    ; row of widgets

  quit   = widget_button (widgets, $                    ; quit ...
    event_pro='quit_event', value='QUIT')               ; ... button
  slider = widget_slider (widgets, $                    ; slider with ..
    min=1, max=points-1, value=1, $                      .. values ..
    event_pro = 'slider_event', $
    title='NUMBER OF WAVELENGTHS')                      ; .. and title

  window = widget_draw (base, xsize=1000, ysize=650, colors=8)

  widget_control, base, /realize                        ; make all widgets
  widget_control, get_value=w1,  window                 ; get window nr
  wset, w1                                              ; select window

  device, decompose=0
  background,[80,100,120]                               ; rgb (blue-green) background
  !x.style=1 & !y.style=3 & !p.multi=0                  ; exact axes, single frame
  !p.psym=0

  cosines, 1, points=points

  xmanager, 'alias', base, /no_block                    ; over to event handler
END
